/* color.h */
typedef struct
{
	CHAR	*name;	/* name of this role */
	CHAR	*descr;	/* args of original :color command */
	long	fg;	/* foreground color code */
	long	bg;	/* background color code */
	unsigned char 	fg_rgb[3];	/* foreground, broken down into RGB */
	unsigned char 	bg_rgb[3];	/* background, broken down into RGB */
	char	like;	/* "like" index, or 0 for nothing */
	char	bits;	/* bitmap of attributes and flags */
} COLORINFO;
#define COLOR_BOLD	0x01
#define COLOR_ITALIC	0x02
#define COLOR_UNDERLINED 0x04
#define COLOR_BOXED	0x08
#define	COLOR_FIXED	0x10
#define COLOR_GRAPHIC	0x1c	/* special blend of underlined, boxed, fixed */
#define COLOR_FG	0x20
#define COLOR_BG	0x40
#define	COLOR_SET	0x80

extern COLORINFO colorinfo[128];
extern int colorfind P_((CHAR *fontname));
extern COLORINFO *colorcombine P_((int oldfont, COLORINFO *newcinfo));
extern void colorset P_((int fontcode, CHAR *descr, BOOLEAN explicit));
extern void colorforeign P_((CHAR *name, CHAR *descr));
extern void colorsetup P_((void));
extern int colortmp P_((int oldfont, int newfont));
extern void colorlist P_((WINDOW win, CHAR *name));
#ifdef FEATURE_MKEXRC
extern void colorsave P_((BUFFER buf));
#endif
#ifdef FEATURE_COMPLETE
extern CHAR *colorcomplete P_((WINDOW win, MARK from, MARK to));
#endif
